//$Id: sinfo.dpr,v 1.1.1.1 2007/08/24 09:49:23 amodigli Exp $
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//COPYRIGHT (c) 2004 European Southern Observatory
//LICENSE
//
//PROJECT:   VLT Data Flow System
//AUTHOR:    A.Modigliani - ESO/DMD/DPG
//SUBSYSTEM: SINFONI Instrument Pipeline
//PURPOSE:   Definition of reduction rules
//
//$Name: sinfo-2_2_5 $
//$Revision: 1.1.1.1 $
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

instrument: "SINFONI";
name:       "$Id: sinfo.dpr,v 1.1.1.1 2007/08/24 09:49:23 amodigli Exp $";
version:    "$Revision: 1.1.1.1 $";


load_ima(REF_IMAGE){
    execute load_ima(REF_IMAGE);
}

sinfo_rec_distortion(REF_IMAGE){
 if (ref_line_arc=gen_query(REF_IMAGE, DO_CATG=REF_LINE_ARC,
              MIN_RET=1, MAX_RET=1) &&
     drs_setup=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_WAVE,
              MIN_RET=1, MAX_RET=1))
    execute sinfo_rec_distortion(REF_IMAGE, ref_line_arc, drs_setup);
}

sinfo_rec_detlin(REF_IMAGE){
    execute sinfo_rec_detlin(REF_IMAGE);
}

sinfo_rec_mdark(REF_IMAGE){
    execute sinfo_rec_mdark(REF_IMAGE);
}

sinfo_rec_mflat(REF_IMAGE){
 if (ref_bp_map=gen_query(REF_IMAGE, DO_CATG=REF_BP_MAP,
              MIN_RET=1, MAX_RET=1) &&
         bp_map=gen_query(REF_IMAGE, DO_CATG=BP_MAP_NL,
              MIN_RET=1, MAX_RET=1))

    execute sinfo_rec_mflat(REF_IMAGE, ref_bp_map, bp_map);
}


sinfo_rec_wavecal(REF_IMAGE){
  if (ref_line_arc=gen_query(REF_IMAGE, DO_CATG=REF_LINE_ARC,
              MIN_RET=1, MAX_RET=1) &&
      drs_setup=gen_query(REF_IMAGE, DO_CATG=DRS_SETUP_WAVE,
              MIN_RET=1, MAX_RET=1) &&
      mflat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_LAMP,
              MIN_RET=1, MAX_RET=1) &&
      bp_map=gen_query(REF_IMAGE, DO_CATG=MASTER_BP_MAP,
              MIN_RET=1, MAX_RET=1) &&
      slit_pos=gen_query(REF_IMAGE, DO_CATG=SLIT_POS,
              MIN_RET=1, MAX_RET=1) &&
      distortion=gen_query(REF_IMAGE, DO_CATG=DISTORTION,
              MIN_RET=1, MAX_RET=1))

    execute sinfo_rec_wavecal(REF_IMAGE, ref_line_arc,drs_setup,mflat,bp_map,slit_pos,distortion);
}


sinfo_rec_jitter(REF_IMAGE){
  if (bp_map=gen_query(REF_IMAGE, DO_CATG=MASTER_BP_MAP,
              MIN_RET=1, MAX_RET=1) &&
      mflat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_LAMP,
              MIN_RET=1, MAX_RET=1) &&
      mdark=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK,
              MIN_RET=0, MAX_RET=1) &&
      fcol=gen_query(REF_IMAGE, DO_CATG=FIRST_COL,
              MIN_RET=1, MAX_RET=1) &&
      wave_map=gen_query(REF_IMAGE, DO_CATG=WAVE_MAP,
              MIN_RET=1, MAX_RET=1) &&
      distances=gen_query(REF_IMAGE, DO_CATG=SLITLETS_DISTANCE,
              MIN_RET=1, MAX_RET=1) &&
      slit_pos=gen_query(REF_IMAGE, DO_CATG=SLIT_POS,
              MIN_RET=1, MAX_RET=1) &&
      distortion=gen_query(REF_IMAGE, DO_CATG=DISTORTION,
              MIN_RET=1, MAX_RET=1))

    execute sinfo_rec_jitter(REF_IMAGE,bp_map,mflat,mdark,fcol,wave_map,distances,slit_pos,distortion);
}



sinfo_rec_pupil(REF_IMAGE){
  if (bp_map=gen_query(REF_IMAGE, DO_CATG=MASTER_BP_MAP,
              MIN_RET=1, MAX_RET=1) &&
      mflat=gen_query(REF_IMAGE, DO_CATG=MASTER_FLAT_LAMP,
              MIN_RET=1, MAX_RET=1) &&
      mdark=gen_query(REF_IMAGE, DO_CATG=MASTER_DARK,
              MIN_RET=0, MAX_RET=1) &&
      fcol=gen_query(REF_IMAGE, DO_CATG=FIRST_COL,
              MIN_RET=1, MAX_RET=1) &&
      wave_map=gen_query(REF_IMAGE, DO_CATG=WAVE_MAP,
              MIN_RET=1, MAX_RET=1) &&
      distances=gen_query(REF_IMAGE, DO_CATG=SLITLETS_DISTANCE,
              MIN_RET=1, MAX_RET=1) &&
      slit_pos=gen_query(REF_IMAGE, DO_CATG=SLIT_POS,
              MIN_RET=1, MAX_RET=1) &&
      distortion=gen_query(REF_IMAGE, DO_CATG=DISTORTION,
              MIN_RET=1, MAX_RET=1))

    execute sinfo_rec_pupil(REF_IMAGE,bp_map,mflat,mdark,fcol,wave_map,distances,slit_pos,distortion);
}
